//*****************************************
// AVR ATtiny13A Dekatron(OG-3) Check Program
// CPU Clock:9.6MHz
//
// File Name:dekatron.c
//
// 	fJginf|Rj̉]
//  PB2 : G1
//  PB3 : G2
//  PB4 : G3
//
//
//  2016/08/30 New(TAB4)  Taishi
//*****************************************

#include	<avr/io.h>

#include	"og3_spinner.h"
#include	"timer.h"
#include	"dekatron.h"

// ************************************
//  KChnmԁij
// ************************************
static	void	one_guide_ontime(void)
{
	if(slow != 0){					// x鎞
		delay_ms(100);				// 100mS
	}else{
		delay_2us(250/2);			// 250uS
	}
}

// ************************************
//  KChnmԁij
// ************************************
static	void	tow_guide_ontime(void)
{
	if(slow != 0){					// x鎞
		delay_ms(10);				// 10mS
	}else{
		delay_2us(10/2);			// 10uS
	}
}

// ************************************
//  ړi]j̏ݒ
// ************************************
void	move_init(void)
{
	DDRB  |= ((1 << DDB2) | (1 << DDB3) | (1 << DDB4));		// Port-B Bit2,3,4 : Output
	PORTB &= ~((1 << PB2) | (1 << PB3) | (1 << PB4));		// PB2,3,4 Low
}

// ************************************
//  ړ
//   dir: 0=CW, 1=CCW
// ************************************
void	move_one(unsigned char dir)
{
	if(dir == 0){											//CW
		PORTB |= (1 << PB2);								// G1:ON
		one_guide_ontime();									// KChnmԁij
		PORTB |= (1 << PB3);								// G1,G2:ON
		tow_guide_ontime();									// KChnmԁij
		PORTB &= ~(1 << PB2);								// G2:ON
		one_guide_ontime();									// KChnmԁij
		PORTB |= (1 << PB4);								// G2,G3:ON
		tow_guide_ontime();									// KChnmԁij
		PORTB &= ~(1 << PB3);								// G3:ON
		one_guide_ontime();									// KChnmԁij
		PORTB &= ~(1 << PB4);								// G3:OFF
	}else{
		PORTB |= (1 << PB4);								// G3:ON
		one_guide_ontime();									// KChnmԁij
		PORTB |= (1 << PB3);								// G3,G2:ON
		tow_guide_ontime();									// KChnmԁij
		PORTB &= ~(1 << PB4);								// G2:ON
		one_guide_ontime();									// KChnmԁij
		PORTB |= (1 << PB2);								// G2,G1:ON
		tow_guide_ontime();									// KChnmԁij
		PORTB &= ~(1 << PB3);								// G1:ON
		one_guide_ontime();									// KChnmԁij
		PORTB &= ~(1 << PB2);								// G1:OFF
	}
}
